
/*  Copyright (C) 2002 Secure Systems Lab, Stony Brook. 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program (See file COPYING in the main directory); 
    if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/*   Written by Tapan Kamat tkamat@cs.sunysb.edu */

/**
 * This interface defines the mothods that an object must implement so
 * that when it's wrapped by a DefaultTreeCellRenderer a checkbox is displayed
 * in front of the tree node.
 *
 */

public interface Checkable {
  /**
   * Returns whether the current state of the object should be drawn as
   * checked or unchecked in the CheckTree.
   *
   * @return True or false.
   */
  public boolean isChecked();

  /**
   * Sets whether the current state of the object should be drawn as
   * checked or unchecked in the CheckTree.
   *
   * @param v True or false.
   */
  public void setChecked(boolean v);
} 
