

/*  Copyright (C) 2002 Secure Systems Lab, Stony Brook. 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program (See file COPYING in the main directory); 
    if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/*   Written by Tapan Kamat tkamat@cs.sunysb.edu */

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;

class GeneralOptionsDialog extends JDialog
{
    Container dialogpane;

    JTabbedPane jtpPane;

    JPanel jpCurrentDirectory;
    JLabel jlCurrentDirectory;
    JTextField jtfCurrentDirectory;
    JFileChooser jfCurrentChoose;
    JButton jbCurrentBrowse;
    JButton jbCurrentApply;
    JButton jbCurrentCancel;

    JPanel jpSharedDirectories;
    JTable jtShared;
    MyTableModel tableModel;
    JScrollPane jspShared;
    JPanel jpEastButtonPanel;
    JButton jbSharedAdd;
    JButton jbSharedRemove;
    JPanel jpSouthButtonPanel;
    JLabel jlSharedDirectory;
    JTextField jtfSharedDirectory;
    JFileChooser jfSharedChoose;
    JButton jbSharedBrowse;
    JButton jbSharedApply;
    JButton jbSharedCancel;

    JButton jbClose;
    MyActionListener myActionListener;

    Vector vecShared;

    public GeneralOptionsDialog()
    {
	super();
	dialogpane = getContentPane();
	dialogpane.setLayout(null);
	setModal(true);
	setResizable(false);
	setTitle("General Options");	    
	setLocation((int)Math.round(0.2539 * Constants.UINTER_WIDTH),(int)Math.round(0.2567 * Constants.UINTER_HEIGHT));   // 325 x 250
	setSize((int)Math.round(0.5234 * Constants.UINTER_WIDTH),(int)Math.round(0.5133 * Constants.UINTER_HEIGHT));	   // 670 x 500
	setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);

        addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
		System.out.println("Window close clicked");
            }
        });

	myActionListener = new MyActionListener();
	GUI.currentDirectory = System.getProperty("user.home");
	vecShared = new Vector();
	backupVector();

	jtpPane = new JTabbedPane();
 	jtpPane.setLocation((int)Math.round(0.0156 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT));// 20 x 20
 	jtpPane.setSize(new Dimension((int)Math.round(0.4844 * Constants.UINTER_WIDTH),(int)Math.round(0.4107 * Constants.UINTER_HEIGHT)));  //620 x 400	

	// Current Directory Tab Panel
	jpCurrentDirectory = new JPanel();
 	jpCurrentDirectory.setLayout(null);
	jpCurrentDirectory.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.0103 * Constants.UINTER_HEIGHT));  //10 x 10	
	jpCurrentDirectory.setSize(new Dimension((int)Math.round(0.4688 * Constants.UINTER_WIDTH),(int)Math.round(0.3593 * Constants.UINTER_HEIGHT)));	// 600 x 350

	jlCurrentDirectory = new JLabel("Current Directory : ");
	jlCurrentDirectory.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.1643 * Constants.UINTER_HEIGHT));/// 10 x 160	
	jlCurrentDirectory.setSize(jlCurrentDirectory.getPreferredSize());
	jtfCurrentDirectory = new JTextField((int)Math.round(0.2343 * Constants.UINTER_WIDTH));  // 300
	jtfCurrentDirectory.setLocation((int)Math.round(0.1250 * Constants.UINTER_WIDTH),(int)Math.round(0.1643 * Constants.UINTER_HEIGHT));// 160 x 160
	jtfCurrentDirectory.setSize(new Dimension((int)Math.round(0.2343 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT))); // 300 x 20	
	jtfCurrentDirectory.setText(System.getProperty("user.home"));
	jtfCurrentDirectory.setEditable(false);

	jfCurrentChoose = new JFileChooser("user.home");
	jfCurrentChoose.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	jbCurrentBrowse = new JButton("Browse");
	jbCurrentBrowse.setLocation((int)Math.round(0.3750 * Constants.UINTER_WIDTH),(int)Math.round(0.1540 * Constants.UINTER_HEIGHT)); 
// 480 x 150
	jbCurrentBrowse.setSize(new Dimension((int)Math.round(0.0781 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT)));	    // 100 x 30
	jbCurrentBrowse.addActionListener(myActionListener);

	jbCurrentApply = new JButton("Apply");
	jbCurrentApply.setEnabled(false);
	jbCurrentApply.setLocation((int)Math.round(0.1641 * Constants.UINTER_WIDTH),(int)Math.round(0.3183 * Constants.UINTER_HEIGHT));     // 210 x 310
	jbCurrentApply.setSize((int)Math.round(0.0781 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT));//100 x 30
	jbCurrentApply.addActionListener(myActionListener);

	jbCurrentCancel = new JButton("Cancel");
	jbCurrentCancel.setLocation((int)Math.round(0.2422 * Constants.UINTER_WIDTH),(int)Math.round(0.3183 * Constants.UINTER_HEIGHT)); //310 x 310
	jbCurrentCancel.setSize((int)Math.round(0.0781 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT));//100x30
	jbCurrentCancel.addActionListener(myActionListener);

	jpCurrentDirectory.add(jlCurrentDirectory);
	jpCurrentDirectory.add(jtfCurrentDirectory);
	jpCurrentDirectory.add(jbCurrentBrowse);
	jpCurrentDirectory.add(jbCurrentApply);
	jpCurrentDirectory.add(jbCurrentCancel);

	// Shared Directories Tab Panel
	jpSharedDirectories = new JPanel();		
 	jpSharedDirectories.setLayout(null);
	jpSharedDirectories.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.0103 * Constants.UINTER_HEIGHT)); //10 x 10	
	jpSharedDirectories.setSize(new Dimension((int)Math.round(0.4688 * Constants.UINTER_WIDTH),(int)Math.round(0.3593 * Constants.UINTER_HEIGHT))); // 600 x 350	

        tableModel = new MyTableModel();
	jtShared = new JTable(tableModel);
	jtShared.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	jtShared.setPreferredScrollableViewportSize(new Dimension((int)Math.round(0.3516 * Constants.UINTER_WIDTH),(int)Math.round(0.1951 * Constants.UINTER_HEIGHT))); // 450 x 190	    
 
        jspShared = new JScrollPane(jtShared);
	jspShared.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT)); //10 x 20
	jspShared.setSize(new Dimension((int)Math.round(0.3594 * Constants.UINTER_WIDTH),(int)Math.round(0.2053 * Constants.UINTER_HEIGHT))); // 460 x200

	// East Panel
	jpEastButtonPanel = new JPanel();
	jpEastButtonPanel.setLayout(null);
	jpEastButtonPanel.setLocation((int)Math.round(0.3750 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT)); // 480,20
	jpEastButtonPanel.setSize(new Dimension((int)Math.round(0.0938 * Constants.UINTER_WIDTH),(int)Math.round(0.2053 * Constants.UINTER_HEIGHT))); // 120,200
	
	jbSharedAdd = new JButton("Add");
	jbSharedAdd.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.0719 * Constants.UINTER_HEIGHT)); // 10,70
	jbSharedAdd.setSize(new Dimension((int)Math.round(0.0859 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT))); // 110,30	    
	jbSharedAdd.addActionListener(myActionListener);

	jbSharedRemove = new JButton("Remove");
	jbSharedRemove.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.1232 * Constants.UINTER_HEIGHT)); // 10,120
	jbSharedRemove.setSize(new Dimension((int)Math.round(0.0859 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT))); // 110,30	    
	jbSharedRemove.addActionListener (myActionListener);

	jpEastButtonPanel.add(jbSharedAdd);
	jpEastButtonPanel.add(jbSharedRemove);

	// South Panel
	jpSouthButtonPanel = new JPanel();
	jpSouthButtonPanel.setLayout(null);
	jpSouthButtonPanel.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.2259 * Constants.UINTER_HEIGHT)); // 10,220
	jpSouthButtonPanel.setSize(new Dimension((int)Math.round(0.4688 * Constants.UINTER_WIDTH),(int)Math.round(0.1232 * Constants.UINTER_HEIGHT))); // 600,120

	jlSharedDirectory = new JLabel("Current Directory : ");
	jlSharedDirectory.setLocation((int)Math.round(0.0078 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT)); // 10,20	
	jlSharedDirectory.setSize(new Dimension((int)Math.round(0.1367 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT))); // 175,20
	jtfSharedDirectory = new JTextField((int)Math.round(0.2343 * Constants.UINTER_WIDTH)); // 300
	jtfSharedDirectory.setLocation((int)Math.round(0.1094 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT)); // 140,20
	jtfSharedDirectory.setSize(new Dimension((int)Math.round(0.2500 * Constants.UINTER_WIDTH),(int)Math.round(0.0205 * Constants.UINTER_HEIGHT))); // 320,20	
	jtfSharedDirectory.setText(System.getProperty("user.home"));

	jfSharedChoose = new JFileChooser("user.home");
	jfSharedChoose.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	jbSharedBrowse = new JButton("Browse");
	jbSharedBrowse.setLocation((int)Math.round(0.3750 * Constants.UINTER_WIDTH),(int)Math.round(0.0154 * Constants.UINTER_HEIGHT)); // 480,15
	jbSharedBrowse.setSize(new Dimension((int)Math.round(0.0859 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT))); // 110,30	    
	jbSharedBrowse.addActionListener(myActionListener);
	
	jbSharedApply = new JButton("Apply");
	jbSharedApply.setEnabled(false);
	jbSharedApply.setLocation((int)Math.round(0.1641 * Constants.UINTER_WIDTH),(int)Math.round(0.0719 * Constants.UINTER_HEIGHT)); // 210,70
	jbSharedApply.setSize(new Dimension((int)Math.round(0.0781 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT))); // 100,30	    
	jbSharedApply.addActionListener(myActionListener);

	jbSharedCancel = new JButton("Cancel");
	jbSharedCancel.setLocation((int)Math.round(0.2422 * Constants.UINTER_WIDTH),(int)Math.round(0.0719 * Constants.UINTER_HEIGHT)); //310,70
	jbSharedCancel.setSize(new Dimension((int)Math.round(0.0781 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT))); // 100,30	    
	jbSharedCancel.addActionListener(myActionListener);

	jpSouthButtonPanel.add(jlSharedDirectory);
	jpSouthButtonPanel.add(jtfSharedDirectory);
	jpSouthButtonPanel.add(jbSharedBrowse);	
	jpSouthButtonPanel.add(jbSharedApply);
	jpSouthButtonPanel.add(jbSharedCancel);

        //Add the scroll pane and button panels to the panel .
        jpSharedDirectories.add(jspShared);
	jpSharedDirectories.add(jpEastButtonPanel);
	jpSharedDirectories.add(jpSouthButtonPanel);	

	// Add the panels to the tab pane
	jtpPane.add("Current Directory",jpCurrentDirectory);
	jtpPane.add("Shared Directories",jpSharedDirectories);
	jtpPane.setSelectedIndex(0);
				   
				   // This is the Close button
	jbClose = new JButton("Close");
	jbClose.setLocation((int)Math.round(0.2266 * Constants.UINTER_WIDTH),(int)Math.round(0.4415 * Constants.UINTER_HEIGHT));//290,565  
	jbClose.setSize(new Dimension((int)Math.round(0.0703 * Constants.UINTER_WIDTH),(int)Math.round(0.0308 * Constants.UINTER_HEIGHT))); // 90, 30	    	   
	jbClose.addActionListener(myActionListener);

	jtpPane.addChangeListener(new ChangeListener()
	{
	    public void stateChanged(ChangeEvent e)
	    {
		int index = jtpPane.getSelectedIndex();
		String title = jtpPane.getTitleAt(index);
		if (title.equals("Current Directory"))
		{
		    if (jbSharedApply.isEnabled())
		    {
			jtpPane.setSelectedIndex(1);
			displayWarning();
		    }
		}
		else if (title.equals("Shared Directories"))
		{
		    if (jbCurrentApply.isEnabled())
		    {
			jtpPane.setSelectedIndex(0);
			displayWarning();
		    }
		}
	    }
	});	

	// Add all components to the contentpane
	dialogpane.add(jtpPane);
	dialogpane.add(jbClose);
    }

    /* Listens to the push as well as radio buttons. */
    private class MyActionListener implements ActionListener 
    {
        public void actionPerformed(ActionEvent e) 
	{
	    if (e.getSource() == jbClose)
	    {	
		int index = jtpPane.getSelectedIndex();
		String title = jtpPane.getTitleAt(index);
		if (title.equals("Current Directory"))
		{
		    if (jbCurrentApply.isEnabled())
			displayWarning();
		    else
			dispose();
		}
		else if (title.equals("Shared Directories"))
		{
		    if (jbSharedApply.isEnabled())
			displayWarning();		    
		    else
			dispose();
		}
	    }
	    if (e.getSource() == jbCurrentBrowse)
	    {
		int fileChoice = jfCurrentChoose.showOpenDialog(dialogpane);
		if (fileChoice == JFileChooser.APPROVE_OPTION)
		{
		    File dirName = jfCurrentChoose.getSelectedFile();
		    String dirAbsPath = dirName.getAbsolutePath();
		    if (! dirAbsPath.equals(GUI.currentDirectory))
		    {
			jtfCurrentDirectory.setText(dirAbsPath);
			jbCurrentApply.setEnabled(true);
		    }
		}
	    }
	    else if (e.getSource() == jbCurrentApply)
	    {
		applyChanges();
	    }
	    else if (e.getSource() == jbCurrentCancel)
	    {
		cancelChanges();
	    }
	    else if (e.getSource() == jbSharedBrowse)
	    {
		int fileChoice = jfSharedChoose.showOpenDialog(dialogpane);
		if (fileChoice == JFileChooser.APPROVE_OPTION)
		{
		    File dirName = jfSharedChoose.getSelectedFile();
		    String dirAbsPath = dirName.getAbsolutePath();
		    jtfSharedDirectory.setText(dirAbsPath);
		}
	    }
	    else if (e.getSource() == jbSharedApply)
	    {
		applyChanges();
		//printVector();	    
	    }
	    else if (e.getSource() == jbSharedCancel)
	    {
		cancelChanges();
		//printVector();
	    }
	    else if (e.getSource() == jbSharedAdd)
	    {
		String rowcontent = jtfSharedDirectory.getText().trim();
		if (!rowcontent.equals(""))
		    tableModel.addRow(rowcontent);
	    }
	    else if (e.getSource() == jbSharedRemove)
	    {
		int rowindex = jtShared.getSelectedRow();		
		if (rowindex >= 0)
		    tableModel.removeRow(rowindex);
	    }	    
	}
    }

    private void applyChanges()
    {
	int index = jtpPane.getSelectedIndex();
	String title = jtpPane.getTitleAt(index);
	if (title.equals("Current Directory"))
	{
	    GUI.currentDirectory = jtfCurrentDirectory.getText();
	    jbCurrentApply.setEnabled(false);
	}
	else if (title.equals("Shared Directories"))
	{
	    backupVector();
	    saveToIni();
	    jbSharedApply.setEnabled(false);
	}	
    }

    private void cancelChanges()
    {
	int index = jtpPane.getSelectedIndex();
	String title = jtpPane.getTitleAt(index);
	if (title.equals("Current Directory"))
	{
	    if (! jbCurrentApply.isEnabled())
		return;

	    jtfCurrentDirectory.setText(GUI.currentDirectory);
	    jbCurrentApply.setEnabled(false);
	}
	else if (title.equals("Shared Directories"))
	{
	    if (! jbSharedApply.isEnabled())
		return;

	    int size = GUI.sharedDirectories.size();
	    for (int i = size - 1; i >= 0 ; i--)
		tableModel.removeRow(i);

	    for (int i = 0; i < vecShared.size(); i++)
	    {
		String s = (String) vecShared.elementAt(i);
		tableModel.addRow(s);
	    }
	    jbSharedApply.setEnabled(false);
	}	
    }

    private void displayWarning()
    {
	String msg = "Please use the Apply / Cancel button to save or cancel the changes";
	JOptionPane.showMessageDialog(null,msg,"Unsaved Changes",JOptionPane.INFORMATION_MESSAGE);		    
    }

    private void printVector()
    {
	System.out.println("List of shared dirs : ");
	for (int i = 0 ; i < GUI.sharedDirectories.size(); i++)
	    System.out.println((String) GUI.sharedDirectories.elementAt(i));
	System.out.println("Temp shared vector : ");
	for (int i = 0 ; i < vecShared.size(); i++)
	    System.out.println((String) vecShared.elementAt(i));
    }
    
    private void backupVector()
    {
	Enumeration enumShared = GUI.sharedDirectories.elements();
	vecShared.removeAllElements();
	while(enumShared.hasMoreElements())
	    vecShared.add((String) enumShared.nextElement());
    }

    private void saveToIni()
    {
	BufferedWriter buf = null;
	try
	{
	    String ininame = Constants.DEMODIR + "ini/general.ini";
	    buf = new BufferedWriter(new FileWriter(ininame));
	    for (int i = 0 ; i < vecShared.size(); i++)
	    {
		String s = (String) vecShared.elementAt(i);
		buf.write(s + "\n");
	    }		
	    buf.close();
	}
	catch(IOException e)
	{
	    System.out.println("IO Exception in readLine : " + e.getMessage());
	}
	catch (Exception e)
	{
	    System.out.println("Exception in constructor of MyTableModel : " + e.getMessage());
	}
    }

    class MyTableModel extends AbstractTableModel 
    {
        final String[] columnNames = {"Shared Directory Paths"};
	Vector data = new Vector();

	public MyTableModel()
	{
	    BufferedReader buf = null;
	    try
	    {
		String ininame = Constants.DEMODIR + "ini/general.ini";
		buf = new BufferedReader(new FileReader(ininame));
		String s;
		while ((s = buf.readLine()) != null)
		{
		    s = s.trim();
		    if (!s.equals(""))
		    {
			data.addElement(s);
			GUI.sharedDirectories.add(s);
			vecShared.add(s);
		    }
		}
		buf.close();
	    }
	    catch(IOException e)
	    {
		System.out.println("IO Exception in readLine : " + e.getMessage());
	    }
	    catch (Exception e)
	    {
		System.out.println("Exception in constructor of MyTableModel : " + e.getMessage());
	    }
	}

	public int getColumnCount() {
	    return columnNames.length;
	}
        
        public int getRowCount() {
            return data.size();
        }

        public String getColumnName(int col) {
            return columnNames[0];
        }

	public Object getValueAt(int row, int col) {
	    return data.elementAt(row);
	}

	public void addRow(String rowname)
	{
	    if (! data.contains(rowname))
	    {
		data.add(rowname);
		fireTableDataChanged();
		GUI.sharedDirectories.add(rowname);
		jbSharedApply.setEnabled(true);
	    }
	    else
		System.out.println("Already contained : " + rowname);	
	}
	
	public void removeRow(int rowindex)
	{
	    data.remove(rowindex);
	    fireTableDataChanged();
	    GUI.sharedDirectories.remove(rowindex);
	    jbSharedApply.setEnabled(true);		    
	}
    }


    public static void main(String[] args)
    {	
	new GeneralOptionsDialog().show();
    }   
} // end of class
