

/*  Copyright (C) 2002 Secure Systems Lab, Stony Brook. 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program (See file COPYING in the main directory); 
    if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/*   Written by Tapan Kamat tkamat@cs.sunysb.edu */

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

public class RPMFileFilter extends FileFilter 
{   
    // Accept all directories and all .rpm files
    public boolean accept(File f) 
    {
        if (f.isDirectory()) 
            return true;

        String extension = CommonMethods.getExtension(f);
	if (extension != null) 
	{
            if (extension.equals("rpm"))
		return true;
	    else
                return false;
	}
        return false;
    }
   
    // The description of this filter
    public String getDescription() 
    {
        return "RPM Packages";
    }
}
