

/*  Copyright (C) 2002 Secure Systems Lab, Stony Brook. 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program (See file COPYING in the main directory); 
    if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/*   Written by Tapan Kamat tkamat@cs.sunysb.edu */

import java.io.*;

public class TreeAction
{
    Runtime theSystem;

    public TreeAction()
    {
	theSystem = Runtime.getRuntime();
    }

    /* Following functions have been added by Tapan Kamat */
    public void populateDetails(String absPath)
    {
	try
	{
	    String execStr = "rpm -qpi " + absPath;
	    Process proc = theSystem.exec(execStr);
	    try
	    {
		proc.waitFor();
		int val = proc.exitValue();
		BufferedReader buf;
		String s = "";
		buf = new BufferedReader(new InputStreamReader(proc.getInputStream()));
		GUI.jtaPackageInfo.setText(s);
		while ((s = buf.readLine()) != null) 
		{
		    GUI.jtaPackageInfo.append(s + "\n");
		}
	    }
	    catch(Exception excp)
	    {
		System.out.println("Couldn't get the runtime env the 2nd time!");
		excp.printStackTrace();
	    }
	}
	catch(Exception excp)
	{
	    System.out.println("Couldn't get the runtime env the 2nd time!");
	    excp.printStackTrace();
	}	
    }

    public void populateFileList(String absPath)
    {
	try
	{
	    String execStr = "rpm -qpl " + absPath;
	    Process proc = theSystem.exec(execStr);
	    try
	    {
		proc.waitFor();
		int val = proc.exitValue();
		BufferedReader buf;
		String s = "";
		buf = new BufferedReader(new InputStreamReader(proc.getInputStream()));
		GUI.jtaFileList.setText(s);
		while ((s = buf.readLine()) != null) 
		{
		    GUI.jtaFileList.append(s + "\n");
		}
	    }
	    catch(Exception excp)
	    {
		System.out.println("Couldn't get the runtime env the 2nd time!");
		excp.printStackTrace();
	    }
	}
	catch(Exception excp)
	{
	    System.out.println("Couldn't get the runtime env the 2nd time!");
	    excp.printStackTrace();
	}	
    }

    public void populateDependencies(String absPath)
    {
	try
	{
	    String execStr = "rpm -qpR " + absPath;
	    Process proc = theSystem.exec(execStr);
	    try
	    {
		proc.waitFor();
		int val = proc.exitValue();
		BufferedReader buf;
		String s = "";
		buf = new BufferedReader(new InputStreamReader(proc.getInputStream()));
		GUI.jtaDependencies.setText(s);
		while ((s = buf.readLine()) != null) 
		{
		    GUI.jtaDependencies.append(s + "\n");
		}
	    }
	    catch(Exception excp)
	    {
		System.out.println("Couldn't get the runtime env the 2nd time!");
		excp.printStackTrace();
	    }
	}
	catch(Exception excp)
	{
	    System.out.println("Couldn't get the runtime env the 2nd time!");
	    excp.printStackTrace();
	}	
    }
}
